System.register("itay-joystick/ElementStyle", [], function (exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("itay-joystick/WebShit", [], function (exports_2, context_2) {
    "use strict";
    var __moduleName = context_2 && context_2.id;
    var WebShit;
    return {
        setters: [],
        execute: function () {
            WebShit = (function () {
                function WebShit() {
                }
                WebShit.isTranslate3dSupported = function () {
                    // Based on: https://gist.github.com/lorenzopolidori/3794226
                    if (WebShit._isTranslate3dSupported == null) {
                        if (!window.getComputedStyle)
                            return false;
                        var transformProperty = WebShit.getStyleTransformProperty();
                        if (!transformProperty)
                            return false;
                        var computedStyleMap = {
                            webkitTransform: '-webkit-transform',
                            OTransform: '-o-transform',
                            msTransform: '-ms-transform',
                            MozTransform: '-moz-transform',
                            transform: 'transform'
                        };
                        var element = document.createElement('p');
                        document.body.insertBefore(element, null);
                        element.style[transformProperty] = 'translate3d(1px,1px,1px)';
                        var computedStyleTransformValue = getComputedStyle(element).getPropertyValue((computedStyleMap)[transformProperty]);
                        document.body.removeChild(element);
                        WebShit._isTranslate3dSupported =
                            computedStyleTransformValue != null &&
                                computedStyleTransformValue.length > 0 &&
                                computedStyleTransformValue != 'none';
                    }
                    return WebShit._isTranslate3dSupported;
                };
                WebShit.getStyleTransformProperty = function () {
                    if (WebShit._styleTransformProperty === undefined) {
                        WebShit._styleTransformProperty = null;
                        var styles = [
                            'webkitTransform',
                            'MozTransform',
                            'msTransform',
                            'OTransform',
                            'transform'
                        ];
                        var element = document.createElement('p');
                        var style = void 0;
                        for (var i = 0; i < styles.length; i++) {
                            style = styles[i];
                            // TODO: Check if works and clean.
                            if (style in element.style /*element.style[style] != null*/) {
                                WebShit._styleTransformProperty = style;
                                break;
                            }
                        }
                    }
                    return WebShit._styleTransformProperty;
                };
                WebShit.onceElementRendered = function (element, callback) {
                    if (element.clientWidth == 0) {
                        window.requestAnimationFrame(function () { return WebShit.onceElementRendered(element, callback); });
                    }
                    else {
                        callback();
                    }
                };
                return WebShit;
            }());
            WebShit._isTranslate3dSupported = null;
            WebShit._styleTransformProperty = undefined;
            exports_2("WebShit", WebShit);
        }
    };
});
System.register("itay-joystick/JoystickElements", [], function (exports_3, context_3) {
    "use strict";
    var __moduleName = context_3 && context_3.id;
    var JoystickElements;
    return {
        setters: [],
        execute: function () {
            JoystickElements = (function () {
                function JoystickElements() {
                }
                JoystickElements.createStick = function (style) {
                    var canvas = document.createElement('canvas');
                    var size = 50;
                    // let size = 86;
                    canvas.width = size;
                    canvas.height = size;
                    var context = canvas.getContext('2d');
                    if (!context) {
                        throw "Failed to get canvas context '2d'";
                    }
                    context.beginPath();
                    context.arc(canvas.width / 2, canvas.width / 2, 20, 0, Math.PI * 2);
                    context.fillStyle = style.fillColor || "rgba(" + JoystickElements.vanile + ",0.8)";
                    context.fill();
                    // context.lineWidth = 1;
                    // context.strokeStyle = JoystickElements.strokeStyle2;
                    // context.stroke();
                    return canvas;
                };
                JoystickElements.createBase = function (style) {
                    var canvas = document.createElement('canvas');
                    canvas.width = 126;
                    canvas.height = 126;
                    var context = canvas.getContext('2d');
                    if (!context) {
                        throw "Failed to get canvas context '2d'";
                    }
                    context.beginPath();
                    context.arc(canvas.width / 2, canvas.width / 2, 55, 0, Math.PI * 2);
                    context.fillStyle = style.fillColor || "rgba(" + JoystickElements.white + ",0.5)";
                    context.fill();
                    context.lineWidth = 2;
                    context.strokeStyle = JoystickElements.strokeStyle2;
                    context.stroke();
                    return canvas;
                };
                return JoystickElements;
            }());
            JoystickElements.gray = 70;
            JoystickElements.gray2 = 225;
            JoystickElements.strokeStyle = "rgba(" + JoystickElements.gray + "," + JoystickElements.gray + "," + JoystickElements.gray + ",1)";
            JoystickElements.strokeStyle2 = "rgba(" + JoystickElements.gray2 + "," + JoystickElements.gray2 + "," + JoystickElements.gray2 + ",0.3)";
            JoystickElements.vanileSingle = "245";
            JoystickElements.vanile = JoystickElements.vanileSingle + "," + JoystickElements.vanileSingle + "," + JoystickElements.vanileSingle;
            JoystickElements.white = "255,255,255";
            exports_3("JoystickElements", JoystickElements);
        }
    };
});
System.register("itay-joystick", ["itay-joystick/WebShit", "itay-joystick/JoystickElements"], function (exports_4, context_4) {
    "use strict";
    var __moduleName = context_4 && context_4.id;
    var WebShit_1, JoystickElements_1, Joystick;
    return {
        setters: [
            function (WebShit_1_1) {
                WebShit_1 = WebShit_1_1;
            },
            function (JoystickElements_1_1) {
                JoystickElements_1 = JoystickElements_1_1;
            }
        ],
        execute: function () {
            Joystick = (function () {
                function Joystick(options) {
                    var _this = this;
                    this.isMousePressed = false;
                    this.touchId = null;
                    this.isTransform3dSupported = false;
                    this.onTouchStart = function (event) {
                        if (_this.touchId !== null)
                            return;
                        event.preventDefault();
                        var touch = event.changedTouches[0];
                        _this.touchId = touch.identifier;
                        _this.down(touch.clientX, touch.clientY);
                    };
                    this.onTouchEnd = function (event) {
                        if (_this.touchId === null)
                            return;
                        for (var i = 0; i < event.changedTouches.length; i++) {
                            if (event.changedTouches[i].identifier === _this.touchId) {
                                _this.touchId = null;
                                event.preventDefault();
                                _this.up();
                                return;
                            }
                        }
                    };
                    this.onTouchMove = function (event) {
                        if (_this.touchId === null)
                            return;
                        for (var i = 0; i < event.changedTouches.length; i++) {
                            var touch = event.changedTouches[i];
                            if (touch.identifier === _this.touchId) {
                                event.preventDefault();
                                _this.move(touch.clientX, touch.clientY);
                                return;
                            }
                        }
                    };
                    this.onMouseDown = function (event) {
                        event.preventDefault();
                        _this.isMousePressed = true;
                        _this.down(event.clientX, event.clientY);
                    };
                    this.onMouseUp = function () {
                        _this.isMousePressed = false;
                        _this.up();
                    };
                    this.onMouseMove = function (event) {
                        if (_this.isMousePressed === true) {
                            _this.move(event.clientX, event.clientY);
                        }
                    };
                    this.container = options.container || document.body;
                    this.style = options.style || {};
                    this.style.stick = this.style.stick || {};
                    this.style.base = this.style.base || {};
                    this.isPreferringCssTransform = options.isPreferringCssTransform || true;
                    this.stickElement = options.stickElement || this.buildStickElement();
                    this.baseElement = options.baseElement || this.buildBaseElement();
                    this.isMouseSupporting = options.isMouseSupporting || false;
                    this.isVisible = options.isVisible || true;
                    this.isStationaryBase = options.isStationaryBase || false;
                    this.baseX = this.stickX = options.baseX || 0;
                    this.baseY = this.stickY = options.baseY || 0;
                    this.isStickLimited = options.isStickLimited || false;
                    this.stickLimitRadius = options.stickLimitRadius || 100;
                    if (this.isPreferringCssTransform) {
                        this.transformProperty = WebShit_1.WebShit.getStyleTransformProperty();
                        this.isTransform3dSupported = WebShit_1.WebShit.isTranslate3dSupported();
                    }
                    this.initializeElements();
                    this.bindListeners();
                }
                Joystick.prototype.destroy = function () {
                    this.container.removeChild(this.baseElement);
                    this.container.removeChild(this.stickElement);
                    this.container.removeEventListener('touchstart', this.onTouchStart, false);
                    this.container.removeEventListener('touchend', this.onTouchEnd, false);
                    this.container.removeEventListener('touchmove', this.onTouchMove, false);
                    if (this.isMouseSupporting) {
                        this.container.removeEventListener('mouseup', this.onMouseUp, false);
                        this.container.removeEventListener('mousedown', this.onMouseDown, false);
                        this.container.removeEventListener('mousemove', this.onMouseMove, false);
                    }
                };
                Joystick.prototype.recalculatePosition = function () {
                    this.baseX = this.getBaseElementCenterX();
                    this.baseY = this.getBaseElementCenterY();
                    this.returnStickToBase();
                };
                Joystick.prototype.getDeltaX = function () {
                    return this.stickX - this.baseX;
                };
                Joystick.prototype.getDeltaY = function () {
                    return this.stickY - this.baseY;
                };
                Joystick.prototype.getBaseElementCenterX = function () {
                    return parseFloat(this.baseElement.style.left) + this.baseElement.clientWidth / 2;
                };
                Joystick.prototype.getBaseElementCenterY = function () {
                    return parseFloat(this.baseElement.style.top) + this.baseElement.clientHeight / 2;
                };
                Joystick.prototype.getStickCenterX = function () {
                    return parseFloat(this.stickElement.style.left) + this.stickElement.clientWidth / 2;
                };
                Joystick.prototype.getStickCenterY = function () {
                    return parseFloat(this.stickElement.style.top) + this.stickElement.clientHeight / 2;
                };
                Joystick.prototype.returnStickToBase = function () {
                    var rect = this.elementsContainer.getBoundingClientRect();
                    this.move(rect.left, rect.top);
                };
                Joystick.prototype.buildStickElement = function () {
                    return JoystickElements_1.JoystickElements.createStick(this.style.stick);
                };
                Joystick.prototype.buildBaseElement = function () {
                    return JoystickElements_1.JoystickElements.createBase(this.style.base);
                };
                Joystick.prototype.initializeElements = function () {
                    this.elementsContainer = document.createElement("div");
                    this.container.appendChild(this.elementsContainer);
                    this.elementsContainer.style.position = "relative";
                    this.elementsContainer.style.width = "0px";
                    this.elementsContainer.style.height = "0px";
                    this.elementsContainer.appendChild(this.baseElement);
                    this.initBaseStyle();
                    this.elementsContainer.appendChild(this.stickElement);
                    this.initStickStyle();
                };
                Joystick.prototype.initBaseStyle = function () {
                    var _this = this;
                    this.baseElement.style.position = "absolute";
                    if (this.isStationaryBase) {
                        this.baseElement.style.display = "";
                        WebShit_1.WebShit.onceElementRendered(this.baseElement, function () {
                            _this.baseElement.style.left = (_this.baseX - _this.baseElement.clientWidth / 2) + "px";
                            _this.baseElement.style.top = (_this.baseY - _this.baseElement.clientHeight / 2) + "px";
                        });
                    }
                    else {
                        this.baseElement.style.display = "none";
                    }
                };
                Joystick.prototype.initStickStyle = function () {
                    var _this = this;
                    this.stickElement.style.position = "absolute";
                    if (!this.isStationaryBase) {
                        this.stickElement.style.display = "none";
                    }
                    else {
                        WebShit_1.WebShit.onceElementRendered(this.baseElement, function () {
                            _this.returnStickToBase();
                        });
                    }
                };
                Joystick.prototype.bindListeners = function () {
                    this.container.addEventListener('touchstart', this.onTouchStart, false);
                    this.container.addEventListener('touchend', this.onTouchEnd, false);
                    this.container.addEventListener('touchmove', this.onTouchMove, false);
                    if (this.isMouseSupporting) {
                        this.container.addEventListener('mousedown', this.onMouseDown, false);
                        this.container.addEventListener('mouseup', this.onMouseUp, false);
                        this.container.addEventListener('mousemove', this.onMouseMove, false);
                    }
                };
                Joystick.prototype.up = function () {
                    if (this.isStationaryBase == false) {
                        this.baseElement.style.display = "none";
                        this.stickElement.style.display = "none";
                        this.baseX = this.baseY = 0;
                    }
                    if (this.onUp) {
                        this.onUp(this);
                    }
                    this.returnStickToBase();
                };
                Joystick.prototype.down = function (x, y) {
                    if (this.isStationaryBase == false) {
                        var rect = this.elementsContainer.getBoundingClientRect();
                        this.baseX = x - rect.left;
                        this.baseY = y - rect.top;
                        if (this.isVisible) {
                            this.baseElement.style.display = "";
                            this.stickElement.style.display = "";
                            this.moveElement(this.baseElement.style, (this.baseX - this.baseElement.clientWidth / 2), (this.baseY - this.baseElement.clientHeight / 2));
                        }
                    }
                    if (this.onDown) {
                        this.onDown(this);
                    }
                    this.moveStick(x, y);
                };
                Joystick.prototype.move = function (x, y) {
                    this.moveStick(x, y);
                    if (this.onDeltaChanged) {
                        this.onDeltaChanged(this);
                    }
                };
                Joystick.prototype.moveStick = function (x, y) {
                    var rect = this.elementsContainer.getBoundingClientRect();
                    this.stickX = x - rect.left;
                    this.stickY = y - rect.top;
                    if (this.isStickLimited === true) {
                        var deltaX = this.getDeltaX();
                        var deltaY = this.getDeltaY();
                        var stickDistance = Math.sqrt((deltaX * deltaX) + (deltaY * deltaY));
                        if (stickDistance > this.stickLimitRadius) {
                            var stickNormalizedX = deltaX / stickDistance;
                            var stickNormalizedY = deltaY / stickDistance;
                            this.stickX = stickNormalizedX * this.stickLimitRadius + this.baseX;
                            this.stickY = stickNormalizedY * this.stickLimitRadius + this.baseY;
                        }
                    }
                    if (this.isVisible) {
                        this.moveElement(this.stickElement.style, (this.stickX - this.stickElement.clientWidth / 2), (this.stickY - this.stickElement.clientHeight / 2));
                    }
                };
                // TODO: For performance, split the method and assign to a variable in the ctor.
                // One or Two 'if's per frame is nice.
                Joystick.prototype.moveElement = function (style, x, y) {
                    if (this.transformProperty) {
                        if (this.isTransform3dSupported) {
                            style[this.transformProperty] = 'translate3d(' + x + 'px,' + y + 'px, 0)';
                        }
                        else {
                            style[this.transformProperty] = 'translate(' + x + 'px,' + y + 'px)';
                        }
                    }
                    else {
                        style.left = x + 'px';
                        style.top = y + 'px';
                    }
                };
                return Joystick;
            }());
            exports_4("Joystick", Joystick);
        }
    };
});
